import stanford.karel.*;

public class HurdleJumpingKarel extends SuperKarel {
	public void run() {
		for (int i = 0; i < 8; i++) {
			/* If Karel is facing a hurdle, Karel needs to jump over it.
			 * And otherwise, Karel doesn't, and can just move.
			 */
			if (frontIsClear()) {
				move();
			} else {
				jumpHurdle();
			}
		}
	}
	
	/* Makes Karel jump over a hurdle.
	 * 
	 * Precondition:  Karel is at the base of a hurdle and facing East.
	 * Postcondition: Karel is on the other side of the hurdle and is still
	 *                facing East.
	 */
	private void jumpHurdle() {
		ascendHurdle();
		move();
		descendHurdle();
	}
	
	/* Moves Karel up to the top of a hurdle.
	 * 
	 * Precondition:  Karel is at the base of a hurdle and facing East.
	 * Postcondition: Karel is at the top of the hurdle and is still facing
	 *                East.
	 */
	private void ascendHurdle() {
		turnLeft();
		while (rightIsBlocked()) {
			move();
		}
		turnRight();
	}
	
	/* Makes Karel climb down the hurdle.
	 * 
	 * Precondition:  Karel is on the right side of the hurdle facing East.
	 * Postcondition: Karel at the base of the hurdle, facing East.
	 */
	private void descendHurdle() {
		turnRight();
		while (frontIsClear()) {
			move();
		}
		turnLeft();
	}
}
